package cn.com.qmth.dp.examcloud.oe;

import cn.com.qmth.dp.examcloud.oe.util.PropertiesUtil;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;

/**
 * 启动类
 *
 * @author WANGWEI
 * @date 2019年3月29日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@SpringBootApplication
@Configuration
@EnableAsync
@ComponentScan(basePackages = {"cn.com.qmth"})
public class OeToolApplication {

    static {
        System.setProperty("hibernate.dialect.storage_engine", "innodb");
        PropertiesUtil.loadFromResource("application.properties");
    }

    public static void main(String[] args) {
        SpringApplication.run(OeToolApplication.class, args);

        // UpyunSiteManager.initSite();
        // UpyunSiteManager.initClient();

        Task task = SpringContextHolder.getBean(Task.class);
        task.start();
    }

}
