package cn.com.qmth.dp.examcloud.oe;

import cn.com.qmth.dp.examcloud.oe.modules.export_exam_student_score.ExportExamStudentScore;
import cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion.ExportReduplicateQuestionService;
import cn.com.qmth.dp.examcloud.oe.modules.fixExamStudentId.FixExamStudentId;
import cn.com.qmth.dp.examcloud.oe.modules.get_student_answer_detail.GetStduentAnswerDetailService;
import cn.com.qmth.dp.examcloud.oe.modules.get_student_one_question_answer.GetStduentOneAnswerService;
import cn.com.qmth.dp.examcloud.oe.modules.import_paper_dzkd.ImportPaperDzkdService;
import cn.com.qmth.dp.examcloud.oe.modules.init_user_data_rule.InitUserDataRule;
import cn.com.qmth.dp.examcloud.oe.modules.marking_item_change.MarkingItemChangeService;
import cn.com.qmth.dp.examcloud.oe.modules.update_correct_answer.FixCorrectAnswerAndResetScoreService;
import cn.com.qmth.examcloud.commons.util.JsonUtil;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import cn.com.qmth.examcloud.web.upyun.UpYunPathInfo;
import cn.com.qmth.examcloud.web.upyun.UpyunPathEnvironmentInfo;
import cn.com.qmth.examcloud.web.upyun.UpyunService;
import com.mongodb.client.FindIterable;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoCursor;
import org.apache.commons.lang3.RandomUtils;
import org.bson.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.List;
import java.util.Map;

/**
 * 任务
 *
 * @author WANGWEI
 * @date 2019年9月6日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Component
public class Task {

    private static final Logger log = LoggerFactory.getLogger(Task.class);

    /**
     * 方法注释
     *
     * @author WANGWEI
     */
    public void start() {
        try {

            // SpringContextHolder.getBean(ImportPaperDzkdService.class).start();
            // SpringContextHolder.getBean(FixCorrectAnswerAndResetScoreService.class).start();
            // SpringContextHolder.getBean(ExportExamStudentScore.class).start(123L);
            // SpringContextHolder.getBean(GetStduentOneAnswerService.class).start(1213L, 1, "01");
            // SpringContextHolder.getBean(GetStduentAnswerDetailService.class).start(1627L, "000004");
            // SpringContextHolder.getBean(InitUserDataRule.class).start();
            // SpringContextHolder.getBean(FixExamStudentId.class).start(2843L, null);
            // SpringContextHolder.getBean(MarkingItemChangeService.class).start();
            // SpringContextHolder.getBean(ExportReduplicateQuestionService.class).start();

        } catch (Exception e) {
            log.error("unexpected", e);
            throw new RuntimeException(e);
        }
    }

    /**
     * 连接测试
     *
     * @author WANGWEI
     */
    public static void test() {

        UpyunService upyunService = SpringContextHolder.getBean(UpyunService.class);
        UpyunPathEnvironmentInfo env = new UpyunPathEnvironmentInfo();
        env.setFileSuffix(".jpg");
        env.setRootOrgId(String.valueOf(RandomUtils.nextLong()));
        UpYunPathInfo upYunPathInfo = upyunService.writeFile("test", env,
                new File("D:/Temp/111111X.jpg"), true);
        System.out.println("upYunPathInfo: " + JsonUtil.toPrettyJson(upYunPathInfo));

        JdbcTemplate jdbcTemplate = SpringContextHolder.getBean(JdbcTemplate.class);
        List<Map<String, Object>> list = jdbcTemplate.queryForList("SELECT now() FROM dual");
        System.out.println(JsonUtil.toJson(list));

        MongoTemplate mongoTemplate = SpringContextHolder.getBean(MongoTemplate.class);
        String dbName = mongoTemplate.getDb().getName();
        System.out.println("mongo.db=" + dbName);
        MongoCollection<Document> collection = mongoTemplate.getCollection("examRecordQuestions");
        Document filter = new Document();
        filter.append("examRecordDataId", 101373L);
        FindIterable<Document> iterable = collection.find(filter);
        MongoCursor<Document> iterator = iterable.iterator();
        while (iterator.hasNext()) {
            Document next = iterator.next();

            System.out.println("_id=" + next.getObjectId("_id"));
            System.out.println(JsonUtil.toPrettyJson(next));
        }
    }

}
