package cn.com.qmth.dp.examcloud.oe.bean;

import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.validation.constraints.NotNull;

/**
 * 评卷项 Created by zhengmin on 2016/12/12.
 */
public class MarkItemEntity  {

    enum ScoringType {
        /**
         * 根据给分间隔
         */
        INTERVAL,
        /**
         * 人工指定给分列表
         */
        MANUAL
    }

    private String basePaperId;

    private Long workId;

    private Long markRangeId;

    /**
     * 大题号
     */
    private int mainNumber;

    /**
     * 小题号
     */
    private int subNumber;

    /**
     * 全试卷范围内题号顺序
     */
    private int orders;

    /**
     * 分值
     */
    private double maxScore;

    /**
     * 给分方式
     */
    @Enumerated(EnumType.STRING)
    private ScoringType scoringType;

    /**
     * 给分间隔
     */
    private Double scoreInterval;

    /**
     * 给分列表
     */
    private String socreList;

    /**
     * 题Id
     */
    private String questionId;

    public MarkItemEntity() {
    }

    public MarkItemEntity(String basePaperId, int mainNumber, int subNumber, double maxScore, Double scoreInterval,
            int orders, String questionId) {
        this.basePaperId = basePaperId;
        this.mainNumber = mainNumber;
        this.subNumber = subNumber;
        this.maxScore = maxScore;
        this.scoreInterval = scoreInterval == null ? 1 : scoreInterval;
        this.scoringType = ScoringType.INTERVAL;
        this.orders = orders;
        this.questionId = questionId;
    }

    public MarkItemEntity(String basePaperId, int mainNumber, int subNumber, double maxScore, String socreList) {
        this.basePaperId = basePaperId;
        this.mainNumber = mainNumber;
        this.subNumber = subNumber;
        this.maxScore = maxScore;
        this.socreList = socreList == null ? String.valueOf(this.maxScore) : socreList;
        this.scoringType = ScoringType.MANUAL;
    }

    public Long getWorkId() {
        return workId;
    }

    public void setWorkId(Long workId) {
        this.workId = workId;
    }

    public int getMainNumber() {
        return mainNumber;
    }

    public void setMainNumber(int mainNumber) {
        this.mainNumber = mainNumber;
    }

    public int getSubNumber() {
        return subNumber;
    }

    public void setSubNumber(int subNumber) {
        this.subNumber = subNumber;
    }

    public double getMaxScore() {
        return maxScore;
    }

    public void setMaxScore(double maxScore) {
        this.maxScore = maxScore;
    }

    public ScoringType getScoringType() {
        return scoringType;
    }

    public void setScoringType(ScoringType scoringType) {
        this.scoringType = scoringType;
    }

    public Double getScoreInterval() {
        return scoreInterval;
    }

    public void setScoreInterval(Double scoreInterval) {
        this.scoreInterval = scoreInterval;
    }

    public String getSocreList() {
        return socreList;
    }

    public void setSocreList(String socreList) {
        this.socreList = socreList;
    }

    @NotNull
    public String getBasePaperId() {
        return basePaperId;
    }

    public void setBasePaperId(@NotNull String basePaperId) {
        this.basePaperId = basePaperId;
    }

    public Long getMarkRangeId() {
        return markRangeId;
    }

    public void setMarkRangeId(Long markRangeId) {
        this.markRangeId = markRangeId;
    }

    public int getOrders() {
        return orders;
    }

    public void setOrders(int orders) {
        this.orders = orders;
    }

    public String getQuestionId() {
        return questionId;
    }

    public void setQuestionId(String questionId) {
        this.questionId = questionId;
    }
}
