package cn.com.qmth.dp.examcloud.oe.modules.cut_exam_capture_data;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.multithread.Producer;

@Service
public class CutExamCaptureDataProducer extends Producer {

	@Autowired
	private JdbcTemplate jdbcTemplate;

	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		Integer idStep = (Integer) param.get("idStep");
		if(idStep==null) {
			throw new RuntimeException("idStep can not be null");
		}
		Long start = (Long) param.get("startId");
		if(start==null) {
			start= 0L;
		}
		Long maxId=(Long) param.get("maxId");
		if(maxId==null) {
			maxId= getMaxId();
		}
		if(maxId!=null) {
			if(start>=maxId) {
				throw new RuntimeException("param invalid");
			}
			Long end = start+idStep;
			for (;;) {
				offer(new CutExamCaptureDataDto(start, end));
				System.out.println("---------------------produce offer:"+end+"/"+maxId);
				if (end > maxId) {
					break;
				}
				start = start + idStep;
				end = end + idStep;
			}
		}
		System.out.println("---------------------finish!");
	}

	private long getMaxId() {
		String sql = "select max(t.exam_record_data_id) examRecordDataId from ec_oe_exam_capture t";
		Long ret = jdbcTemplate.queryForObject(sql, Long.class);
		return ret;
	}



}
