package cn.com.qmth.dp.examcloud.oe.modules.cut_exam_capture_data;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.web.support.SpringContextHolder;

/**
 * 抓拍数据camareInfos 处理.多线程处理
 * 
 * @author chenken
 *
 */
@Service
public class CutExamCaptureDataService {
	/**
	 * 取数据范围(startId,startId+idStep]。为空取0L
	 */
	private Integer startId = null;
	/**
	 * 整个任务结束判断标志。为空取数据库最大ID
	 */
	private Integer maxId = null;
	/**
	 * 每批数据id间隔。不能为空
	 */
	private Integer idStep = 1000;
	
	/**
	 * 线程数
	 */
	private int threadCount=10;

	public void start() {
		Date s=new Date();
		CutExamCaptureDataProducer pr = SpringContextHolder.getBean(CutExamCaptureDataProducer.class);
		try {
			Map<String, Object> param=new HashMap<>();
			param.put("idStep", idStep);
			param.put("startId", startId);
			param.put("maxId", maxId);
			pr.startDispose(CutExamCaptureDataConsumer.class, threadCount, param);
		} catch (Exception e) {
			throw new RuntimeException(e);

		}
		Date e=new Date();
		System.out.println("time:" + (e.getTime()-s.getTime()));
	}

}
