package cn.com.qmth.dp.examcloud.oe.modules.export_abnormal_boolquestion;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.bson.types.ObjectId;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.entity.question.Paper;
import cn.com.qmth.dp.examcloud.oe.entity.question.PaperDetail;
import cn.com.qmth.dp.examcloud.oe.entity.question.PaperDetailUnit;
import cn.com.qmth.dp.examcloud.oe.entity.question.Question;
import cn.com.qmth.dp.examcloud.oe.excel.ExportUtils;

/**
 * 错误的判断题小题数量
 * 
 * @author chenken
 *
 */
@Service
public class ExportAbnormalBoolQuestionCountService {
	private static Map<String, String> orgMap = new HashMap<String, String>();
	static {
		orgMap.put("0", "启明泰和");
		orgMap.put("1", "石油大学(北京)");
		orgMap.put("115", "测试");
		orgMap.put("135", "山东大学");
		orgMap.put("136", "电子科技大学");
		orgMap.put("137", "陕西师范大学");
		orgMap.put("302", "天津大学");
		orgMap.put("303", "测试大学");
		orgMap.put("371", "西安交通大学");
		orgMap.put("372", "武汉理工大学");
		orgMap.put("718", "西南交通大学");
		orgMap.put("1065", "华中科技大学");
		orgMap.put("1226", "河南优特");
		orgMap.put("1251", "湖北交通职业技术学院");
		orgMap.put("1252", "武汉软件工程职业学院");
		orgMap.put("1256", "华南师范大学");
		orgMap.put("1347", "华中师范大学");
		orgMap.put("1348", "福建师范大学");
		orgMap.put("1350", "优特教育");
		orgMap.put("1353", "奥鹏教育");
		orgMap.put("1384", "西南财经大学");
		orgMap.put("1385", "北京师范大学");
		orgMap.put("1387", "中国地质大学（北京）");
		orgMap.put("1388", "北京开放大学");
		orgMap.put("1394", "西安电子科技大学");
		orgMap.put("1407", "重庆大学");
		orgMap.put("1408", "中国医科大学（奥鹏）");
		orgMap.put("1562", "北京交通大学（奥鹏）");
		orgMap.put("1627", "中国地质大学（武汉）");
		orgMap.put("1680", "南开大学（奥鹏）");
		orgMap.put("1681", "东北师范大学（奥鹏）");
		orgMap.put("1734", "北京航空航天大学（奥鹏）");
		orgMap.put("1745", "中国石油大学（华东）");
		orgMap.put("1759", "教务平台(全日制)");
		orgMap.put("1769", "地质大学（武汉）入学");
		orgMap.put("1775", "演示-ACC");
		orgMap.put("16197", "河南应用技术职业学院");
		orgMap.put("16198", "中国地质大学（北京）入学");
		orgMap.put("16358", "武汉第二轻工业学校");
		orgMap.put("16575", "印刷机构");
		orgMap.put("16801", "启明内考");
		orgMap.put("16816", "华东师范大学");
		orgMap.put("16915", "中南大学");
		orgMap.put("16923", "IPECC-PS小学");
		orgMap.put("16924", "IEPCC-JHS中学");
		orgMap.put("17068", "广东开放大学");
		orgMap.put("17129", "郑州市第四中学");
		orgMap.put("17141", "好学优课");
		orgMap.put("17144", "河南汇龙");
		orgMap.put("17172", "中央音乐学院");
		orgMap.put("17196", "江汉大学");
		orgMap.put("17202", "武汉大学");
		orgMap.put("17332", "华南理工大学-继教院");
		orgMap.put("17349", "华南理工大学-本科");
		orgMap.put("17351", "云南开放大学");
		orgMap.put("17354", "湖北美术学院");
		orgMap.put("17421", "河南财经政法大学");
		orgMap.put("17426", "北京学测教育科技有限公司");
		orgMap.put("17430", "华东师大国际合作交流中心");
		orgMap.put("17439", "齐鲁医药学院");
		orgMap.put("17440", "华中师范大学教务处");
		orgMap.put("17441", "中央美术学院");
		orgMap.put("17457", "青岛滨海学院");
		orgMap.put("17458", "山东协和学院");
		orgMap.put("17459", "齐鲁师范学院");
		orgMap.put("17504", "潍坊理工学院");
		orgMap.put("17506", "赣州职业技术学院");
		orgMap.put("17510", "山东管理学院");
		orgMap.put("17511", "山东现代学院");
		orgMap.put("17512", "青岛港湾职业技术学院");
		orgMap.put("17538", "潍坊医学院");
		orgMap.put("17542", "北京邮电大学");
		orgMap.put("17672", "中央民族大学");
		orgMap.put("17673", "河南大学");
		orgMap.put("17674", "北京语言大学");
		orgMap.put("17682", "大连交通大学");
		orgMap.put("17710", "中国艺术研究院");
		orgMap.put("17781", "深圳第三职业技术学校");
		orgMap.put("17782", "上海大学");
		orgMap.put("17796", "中国社会科学院大学");
		orgMap.put("17797", "西安交通大学入学考试");
		orgMap.put("17798", "福建师范大学-学位");
		orgMap.put("17808", "福建师范课程");
		orgMap.put("17810", "华中师范大学心理学院");
		orgMap.put("17905", "华中师范大学城环学院");
		orgMap.put("17913", "深圳第三职业技术学校-入学");
		orgMap.put("17919", "启明_测试");
		orgMap.put("17933", "中央美术学院附属中等美术学校（央美附中）");
		orgMap.put("18000", "南京大学网院");
		orgMap.put("18005", "上海大学美术学院");
		orgMap.put("18011", "齐鲁医药学院继续教育中心");
		orgMap.put("18108", "四川农业大学");
		orgMap.put("18410", "清华大学美术学院");
		orgMap.put("18414", "四川农业大学wj");
		orgMap.put("18417", "安徽邮电职业技术学院");
		orgMap.put("18420", "中央美术学院继续教育学院");
		orgMap.put("18428", "北京奥鹏远程教育中心有限公司");
		orgMap.put("18462", "河南济源职业技术学院");

	}
	@Autowired
	MongoTemplate mongoTemplate;

	public void start() {
		Date start = new Date();
		Query query = new Query();
		query.addCriteria(Criteria.where("questionType").is("BOOL_ANSWER_QUESTION").and("quesAnswer").exists(true).nin("正确","错误","","<p></p>"));
		List<Question> quess=mongoTemplate.find(query, Question.class, "question");
		if (quess != null && quess.size() > 0) {
			List<RetDto> ret = new ArrayList<RetDto>();
			System.out.println("total:" + quess.size());
			int index = 0;
			for (Question ques : quess) {
				index++;
				System.out.println("index:" + index);
				RetDto dto=new RetDto(ques.getOrgId(), ques.getCourse().getName(), ques.getCourse().getCode(), ques.getQuesAnswer());
				Query query2 = new Query();
				query2.addCriteria(Criteria.where("question.$id").is(new ObjectId(ques.getId())));
				PaperDetailUnit u=mongoTemplate.findOne(query2, PaperDetailUnit.class, "paperDetailUnit");
				dto.setNumber(u.getNumber());
				dto.setPaperName(u.getPaper().getName());
				dto.setQuesName(u.getPaperDetail().getName());
				dto.setOrgName(orgMap.get(ques.getOrgId()));
				ret.add(dto);
			}
			FileOutputStream fos = null;
			try {
				File file = new File("d:/ret.xlsx");
				if (file.exists()) {
					file.delete();
				}
				file.createNewFile();
				fos = new FileOutputStream(file);
				ExportUtils.makeExcel(RetDto.class, ret, fos);
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				if (fos != null) {
					try {
						fos.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		}else {
			System.out.println("total:0");
		}
		Date end = new Date();
		System.out.println("*****************end:" + ((end.getTime() - start.getTime()) / (1000 * 60)) + "分钟");
	}


}
