package cn.com.qmth.dp.examcloud.oe.modules.export_course_questions_count;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.entity.question.Course;
import cn.com.qmth.dp.examcloud.oe.multithread.Producer;

@Service
public class ExportQuesProducer extends Producer {

	@Autowired
	private JdbcTemplate jdbcTemplate;
	
	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		List<Course> cs = getCourse((String)param.get("rootOrgId"));
		if (CollectionUtils.isNotEmpty(cs)) {
			for (Course c : cs) {
				offer(c);
			}
		}
		
		System.out.println("courseCount:" + cs.size());
		
	}
	
	private List<Course> getCourse(String rootOrgId) {
		String sql = "select t.code,t.name,t.id from ec_b_course t where t.root_org_id=" + rootOrgId
				+ " order by t.code";
		RowMapper<Course> rowMapper = new BeanPropertyRowMapper<Course>(Course.class);
		List<Course> ret = jdbcTemplate.query(sql, rowMapper);
		return ret;
	}
	


}
