package cn.com.qmth.dp.examcloud.oe.modules.export_course_questions_diff_count;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.excel.ExportUtils;
import cn.com.qmth.dp.examcloud.oe.multithread.Consumer;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

/**
 * 按科目导出小题各题型数.多线程处理
 * 
 * @author chenken
 *
 */
@Service
public class ExportCourseQuestionsDiffCountService {
	private String rootOrgId = "17351";
	private int threadCount=20;

	public void start() {
		Date s=new Date();
		ExportQuesDiffProducer pr = SpringContextHolder.getBean(ExportQuesDiffProducer.class);
		try {
			Map<String, Object> param=new HashMap<>();
			param.put("rootOrgId", rootOrgId);
			pr.startDispose(ExportQuesDiffConsumer.class, threadCount, param);
			List<CourseQuestionsCountRetDto> ret = new ArrayList<CourseQuestionsCountRetDto>();
			for(Consumer c:pr.getConsumers()) {
				ret.addAll(c.getRet());
			}
			Collections.sort(ret, new Comparator<CourseQuestionsCountRetDto>() {
				@Override
				public int compare(CourseQuestionsCountRetDto o1, CourseQuestionsCountRetDto o2) {
					String c1 = o1.getCourseCode();
					String c2 = o2.getCourseCode();
					return c1.compareTo(c2);
				}

			});
			FileOutputStream fos = null;
			try {
				File file = new File("d:/ret.xlsx");
				if (file.exists()) {
					file.delete();
				}
				file.createNewFile();
				fos = new FileOutputStream(file);
				ExportUtils.makeExcel(CourseQuestionsCountRetDto.class, ret, fos);
			} catch (Exception e) {
				throw new RuntimeException(e);
			} finally {
				if (fos != null) {
					try {
						fos.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		} catch (Exception e) {
			throw new RuntimeException(e);

		}
		Date e=new Date();
		System.out.println("time:" + (e.getTime()-s.getTime()));
	}

}
