package cn.com.qmth.dp.examcloud.oe.modules.export_exam_record_sql_file;

import cn.com.qmth.dp.examcloud.oe.util.FileUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 导出 - 考试明细SQL文件
 */
@Component
public class ExportExamRecordSqlFile {

    private static Logger log = LoggerFactory.getLogger(ExportExamRecordSqlFile.class);

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public void start() {
        List<Long> examIds = new ArrayList<>();

        // examIds.add(1L);

        this.export(examIds);
    }

    private void export(List<Long> examIds) {
        for (Long examId : examIds) {
            List<Map<String, Object>> rows = new ArrayList<>();

            /*
                字段依次含义：

                考试编码 考试批次ID 考试批次名称 姓名 学号 身份证号 准考证号 学生电话 信息采集人
                学习中心代码 学习中心名称 课程代码 课程名称 课程层次 专业 年级
                每次考试持续时间(毫秒) 断点续考次数 考试次数 考试进入时间 考试交卷时间 是否提交交卷
                卷面总分 客观题总分 主观题总分 违纪标志 是否违纪(终审) 校验次数 成功次数 成功率

                select d.id as exam_record_data_id,e.id as exam_id,e.name as exam_name,
                stu.student_name,stu.student_code,stu.identity_number,null as ticket_number,s.phone_number,stu.info_collector,
                org.code as org_code,org.name as org_name,c.code as course_code,c.name as course_name,c.level as course_level,stu.specialty_name,stu.grade,
                d.used_exam_time,d.continued_count,d.exam_order,d.start_time,d.end_time,(case when d.end_time is null then 0 else 1 end) as submit,
                sco.total_score,sco.objective_score,sco.subjective_score,d.is_warn,d.is_illegality,
                d.face_total_count,d.face_success_count,d.face_success_percent
                from ec_oe_exam_record_data d
                inner join ec_oe_exam_score sco on sco.exam_record_data_id = d.id
                inner join ec_oe_exam_student stu on stu.exam_student_id = d.exam_student_id
                inner join ec_e_exam e on e.id = stu.exam_id
                inner join ec_b_student s on s.id = stu.student_id
                inner join ec_b_course c on c.id = stu.course_id
                inner join ec_b_org org on org.id = stu.org_id
                where d.exam_id = 292;
            */

            // todo query

            this.toSqlFile(examId, rows);
        }
    }

    private void toSqlFile(Long examId, List<Map<String, Object>> rows) {
        StringBuilder content = new StringBuilder();

        for (Map<String, Object> row : rows) {
            // todo content
        }

        final String filePath = String.format("/home/admin/project/oe/exam_record_%s.sql", examId);
        FileUtil.writeFile(filePath, content.toString());
    }

}
