package cn.com.qmth.dp.examcloud.oe.modules.fill_property_code;

import java.util.Date;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.bson.types.ObjectId;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;
import org.springframework.stereotype.Service;

import com.mongodb.client.result.UpdateResult;

import cn.com.qmth.dp.examcloud.oe.entity.question.Property;

/**
 * 题库试题属性写入code
 *
 * @author chenken
 */
@Service
public class FillPropertyCodeService {

	@Autowired
	MongoTemplate mongoTemplate;

	public void start() {
		int pageSize = 200;
		int curPage = 1;
		Date start = new Date();
		Query query = new Query();
		long count = this.mongoTemplate.count(query, Property.class);
		query.limit(pageSize);
		System.out.println("总条数:" + count);
		int index = 0;
		for (;;) {
			query.skip((curPage - 1L) * pageSize);
			List<Property> ps = mongoTemplate.find(query, Property.class);
			curPage++;
			if (CollectionUtils.isEmpty(ps)) {
				break;
			}
			for (Property property : ps) {
				index++;
				updatePropertyCode(property.getId());
				System.out
						.println(String.format("处理：%s--> id:%s", index, property.getId()));
			}
		}

		Date end = new Date();
		System.out.println("耗时:" + ((end.getTime() - start.getTime()) / (1000 * 60)) + "分钟");
	}

	public long updatePropertyCode(String id) {
		Query query;
		// 查询相应的题目
		if (id.length() == 24) {
			query = Query.query(Criteria.where("_id").is(new ObjectId(id)));
		} else {
			query = Query.query(Criteria.where("_id").is(id));
		}
		Update update = new Update();
		update.set("code", id);
		UpdateResult upResult = mongoTemplate.updateFirst(query, update, "property");
		long res = upResult.getMatchedCount();

		return res;
	}

}
