package cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.entity.question.Course;
import cn.com.qmth.dp.examcloud.oe.multithread.Producer;
import cn.com.qmth.dp.examcloud.oe.util.ResouceUtil;

@Service
public class ExportQuesReduplicateProducer extends Producer {

	
	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		List<Course> cs = getCourse();
		if (CollectionUtils.isNotEmpty(cs)) {
			for (Course c : cs) {
				offer(c);
			}
		}
		System.out.println("courseCount:" + cs.size());
	}
	
	
	private List<Course> getCourse() {
		List<Course> list=new ArrayList<>();
		XSSFWorkbook wb = null;
		try {
			wb = new XSSFWorkbook(ResouceUtil.getStream("subject_codes.xlsx"));
			XSSFSheet sheet = wb.getSheetAt(0);
			int rows = sheet.getLastRowNum();
			for (int i = 2; i <= rows; i++) {
				Course c = new Course();
				XSSFRow row = sheet.getRow(i);
				String ecCode = row.getCell(0).getStringCellValue().trim();
				String name = row.getCell(1).getStringCellValue().trim();
				c.setCode(ecCode);
				c.setName(name);
				list.add(c);
				
			}
		} catch (IOException e) {
			throw new RuntimeException(e);
		} finally {
			if (wb != null) {
				try {
					wb.close();
				} catch (IOException e) {
				}
			}
		}
		return list;
	}
	

}
