package cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.excel.ExportUtils;
import cn.com.qmth.dp.examcloud.oe.multithread.Consumer;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

@Service
public class ExportReduplicateQuestionService {
	private String rootOrgId = "17351";
	private String paperName = "230517";
	private int threadCount=4;

	public void start() {
		Date s=new Date();
		ExportQuesReduplicateProducer pr = SpringContextHolder.getBean(ExportQuesReduplicateProducer.class);
		try {
			Map<String, Object> param=new HashMap<>();
			param.put("rootOrgId", rootOrgId);
			param.put("paperName", paperName);
			pr.startDispose(ExportQuesReduplicateConsumer.class, threadCount, param);
			List<RetDto> ret = new ArrayList<>();
			int index=0;
			for(Consumer c:pr.getConsumers()) {
				ret.addAll(c.getRet());
				index++;
			}
			FileOutputStream fos = null;
			try {
				File file = new File("d:/ret.xlsx");
				if (file.exists()) {
					file.delete();
				}
				file.createNewFile();
				fos = new FileOutputStream(file);
				ExportUtils.makeExcel(RetDto.class, ret, fos);
			} catch (Exception e) {
				throw new RuntimeException(e);
			} finally {
				if (fos != null) {
					try {
						fos.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		} catch (Exception e) {
			throw new RuntimeException(e);

		}
		Date e=new Date();
		System.out.println("time:" + (e.getTime()-s.getTime()));
	}

}
