package cn.com.qmth.dp.examcloud.oe.modules.update_student_answer;

import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.modules.update_student_answer.entity.FixAnswerType;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

/**
 * 执行图片处理逻辑
 */
@Service
public class FixStudentAnswer {

	private static final Logger log = LoggerFactory.getLogger(FixStudentAnswer.class);

	/**
	 * 修复图片
	 */
	public void startFixPicAnswer(Long examId, String courseCode, int order) {
		FixStudentAnswerService service = SpringContextHolder
				.getBean(FixStudentAnswerService.class);
		String srcPicFileDirectory = "D:/Temp/srcPic";
		try {
			service.fixStudentAnswer(srcPicFileDirectory, examId, courseCode, order,
					FixAnswerType.PICTURE);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			log.error("FileNotFoundException", e);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
			log.error("UnsupportedEncodingException", e);
		} catch (Exception e) {
			log.error("UnkonwnException ", e);
		}
	}

	public void startFixAudioAnswer(Long examId, String courseCode, int order) {
		FixStudentAnswerService service = SpringContextHolder
				.getBean(FixStudentAnswerService.class);
		String srcPicFileDirectory = "D:/Temp/srcAudio";
		try {
			service.fixStudentAnswer(srcPicFileDirectory, examId, courseCode, order,
					FixAnswerType.AUDIO);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			log.error("FileNotFoundException", e);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
			log.error("UnsupportedEncodingException", e);
		} catch (Exception e) {
			log.error("UnkonwnException ", e);
		}
	}
}
