package cn.com.qmth.dp.examcloud.oe.multithread;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.logging.log4j.ThreadContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public abstract class Consumer<T>  extends Thread{
	private static final Logger logger = LoggerFactory.getLogger(Consumer.class);
	private Basket basket;
	
	private List<Object> ret=new ArrayList<>();
	
	private String traceId;
	
	/**
	 * 业务参数
	 */
	private Map<String, Object> param;
	
	public Consumer() {
	}
	@Override
	public void run() {
		logger.info("*******************Consumer:"+Thread.currentThread().getId()+" start");
		try {
			while (true) {
				//先判断是否有异常结束
				if(basket.isExcuteError()) {
					break;
				}
				//取消费数据
				Object o= basket.consume();
				//判断消费数据是否是结束
				if(o instanceof EndObject) {
					break;
				}
				@SuppressWarnings("unchecked")
				T t=(T)o;
//				logger.info("*******************Consumer:"+Thread.currentThread().getId()+" consume");
				//消费数据实现
				consume(this.param,t);
				logger.info("已处理："+basket.updateProcess(1));
			}
		} catch (Exception e) {
			basket.setExcuteError(true);
			logger.error("消费线程处理出错",e);
		}finally {
			basket.countDown();
			logger.info("*******************Consumer:"+Thread.currentThread().getId()+" stop");
			ThreadContext.clearAll();
		}
	}
	public abstract void consume(Map<String, Object> param,T t);
	public Basket getBasket() {
		return basket;
	}
	public void setBasket(Basket basket) {
		this.basket = basket;
	}
	public String getTraceId() {
		return traceId;
	}
	public void setTraceId(String traceId) {
		this.traceId = traceId;
	}
	public List<Object> getRet() {
		return ret;
	}
	
	public void addRet(Object r) {
		ret.add(r);
	}
	protected Map<String, Object> getParam() {
		return param;
	}
	protected void setParam(Map<String, Object> param) {
		this.param = param;
	}
	
	
	
}
