package cn.com.qmth.dp.examcloud.oe.util;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion.QuesOptionDto;
import cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion.QuestionDto;

public class PaperUtil {
    public static String getExtractText(QuestionDto question) {
        StringBuilder quesText = new StringBuilder();
        if (question == null) {
            return quesText.toString();
        }

        if (!StringUtils.isEmpty(question.getQuesBody())) {
            quesText.append(getTextInHtml(question.getQuesBody()));
        }

        List<QuesOptionDto> quesOptionList = question.getQuesOptions();
        if (quesOptionList != null && quesOptionList.size() > 0) {
            for (QuesOptionDto quesOption : quesOptionList) {
                if (!StringUtils.isEmpty(quesOption.getOptionBody())) {
                    quesText.append(getTextInHtml(quesOption.getOptionBody()));
                }
            }
        }

        return quesText.toString();
    }
    public static String getTextInHtml(String htmlStr) {
        htmlStr = htmlStr.replaceAll("\\&[a-zA-Z]{1,10};", "").trim();
        if (!htmlStr.startsWith("<p>")) {
            return htmlStr;
        }

        try {
            org.jsoup.nodes.Document doc = Jsoup.parse(htmlStr);
            StringBuilder textStr = new StringBuilder();
            Elements links = doc.select("p").removeAttr("img");

            for (Element link : links) {
                textStr.append(link.text().trim());
            }

            return textStr.toString();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}
